searchData={"content_type":"text/markdown","items":[{"doc":"","ref":"NervesHubLink.html","title":"NervesHubLink","type":"module"},{"doc":"Checks if the device is connected to the NervesHub device channel.","ref":"NervesHubLink.html#connected?/0","title":"NervesHubLink.connected?/0","type":"function"},{"doc":"Return whether there's currently an active console session","ref":"NervesHubLink.html#console_active?/0","title":"NervesHubLink.console_active?/0","type":"function"},{"doc":"","ref":"NervesHubLink.html#console_connected?/0","title":"NervesHubLink.console_connected?/0","type":"function"},{"doc":"Restart the socket and device channel","ref":"NervesHubLink.html#reconnect/0","title":"NervesHubLink.reconnect/0","type":"function"},{"doc":"Send a file to the connected console","ref":"NervesHubLink.html#send_file/1","title":"NervesHubLink.send_file/1","type":"function"},{"doc":"Send update progress percentage for display in web","ref":"NervesHubLink.html#send_update_progress/1","title":"NervesHubLink.send_update_progress/1","type":"function"},{"doc":"Send an update status to web","ref":"NervesHubLink.html#send_update_status/1","title":"NervesHubLink.send_update_status/1","type":"function"},{"doc":"Checks if the device has a socket connection with NervesHub","ref":"NervesHubLink.html#socket_connected?/0","title":"NervesHubLink.socket_connected?/0","type":"function"},{"doc":"Current status of the update manager","ref":"NervesHubLink.html#status/0","title":"NervesHubLink.status/0","type":"function"},{"doc":"","ref":"NervesHubLink.Application.html","title":"NervesHubLink.Application","type":"module"},{"doc":"","ref":"NervesHubLink.Application.html#start/2","title":"NervesHubLink.Application.start/2","type":"function"},{"doc":"GenServer for handling downloading archives from NervesHub\n\nYour NervesHubLink client will tell the manager when to download\nan archive and the Manager will tell your client when it's done\ndownloading so you can act on it.\n\nYou are expected to remove the file when you're done with it and track\nthat it has been applied to prevent downloading again.","ref":"NervesHubLink.ArchiveManager.html","title":"NervesHubLink.ArchiveManager","type":"module"},{"doc":"Must be called when an archive payload is dispatched from\nNervesHub. the map must contain a `\"url\"` key.","ref":"NervesHubLink.ArchiveManager.html#apply_archive/3","title":"NervesHubLink.ArchiveManager.apply_archive/3","type":"function"},{"doc":"Returns the UUID of the currently downloading archive, or nil.","ref":"NervesHubLink.ArchiveManager.html#currently_downloading_uuid/1","title":"NervesHubLink.ArchiveManager.currently_downloading_uuid/1","type":"function"},{"doc":"Returns the current status of the archive manager","ref":"NervesHubLink.ArchiveManager.html#status/1","title":"NervesHubLink.ArchiveManager.status/1","type":"function"},{"doc":"","ref":"NervesHubLink.ArchiveManager.html#valid_archive?/2","title":"NervesHubLink.ArchiveManager.valid_archive?/2","type":"function"},{"doc":"","ref":"NervesHubLink.ArchiveManager.html#t:status/0","title":"NervesHubLink.ArchiveManager.status/0","type":"type"},{"doc":"","ref":"NervesHubLink.ArchiveManager.html#t:t/0","title":"NervesHubLink.ArchiveManager.t/0","type":"type"},{"doc":"Compute retry backoff intervals used by Slipstream","ref":"NervesHubLink.Backoff.html","title":"NervesHubLink.Backoff","type":"module"},{"doc":"Produce a list of integer backoff delays with jitter\n\nThe first two parameters are minimum and maximum value. These are expected to\nbe milliseconds, but this function doesn't care. The returned list will start\nwith the minimum value and then double it until it reaches the maximum value.\n\nThe third parameter is the amount of jitter to add to each delay. The value\nshould be between 0 and 1. Zero adds no jitter. A value like 0.25 will add up\nto 25% of the delay amount.","ref":"NervesHubLink.Backoff.html#delay_list/3","title":"NervesHubLink.Backoff.delay_list/3","type":"function"},{"doc":"","ref":"NervesHubLink.Certificate.html","title":"NervesHubLink.Certificate","type":"module"},{"doc":"Returns a list of der encoded CA certs","ref":"NervesHubLink.Certificate.html#ca_certs/0","title":"NervesHubLink.Certificate.ca_certs/0","type":"function"},{"doc":"","ref":"NervesHubLink.Certificate.html#key_pem_to_der/1","title":"NervesHubLink.Certificate.key_pem_to_der/1","type":"function"},{"doc":"","ref":"NervesHubLink.Certificate.html#pem_to_der/1","title":"NervesHubLink.Certificate.pem_to_der/1","type":"function"},{"doc":"A behaviour module for customizing if and when firmware updates get applied.\n\nBy default NervesHubLink applies updates as soon as it knows about them from the\nNervesHubLink server and doesn't give warning before rebooting. This let's\ndevices hook into the decision making process and monitor the update's\nprogress.\n\n# Example\n\n```elixir\ndefmodule MyApp.NervesHubLinkClient do\n  @behaviour NervesHubLink.Client\n\n  # May return:\n  #  * `:apply` - apply the action immediately\n  #  * `:ignore` - don't apply the action, don't ask again.\n  #  * `{:reschedule, timeout_in_milliseconds}` - call this function again later.\n\n  @impl NervesHubLink.Client\n  def update_available(data) do\n    if SomeInternalAPI.is_now_a_good_time_to_update?(data) do\n      :apply\n    else\n      {:reschedule, 60_000}\n    end\n  end\nend\n```\n\nTo have NervesHubLink invoke it, add the following to your `config.exs`:\n\n```elixir\nconfig :nerves_hub_link, client: MyApp.NervesHubLinkClient\n```","ref":"NervesHubLink.Client.html","title":"NervesHubLink.Client","type":"behaviour"},{"doc":"","ref":"NervesHubLink.Client.html#archive_available/1","title":"NervesHubLink.Client.archive_available/1","type":"function"},{"doc":"Called when an archive is available for download\n\nMay return one of:\n\n* `download` - Download the archive right now\n* `ignore` - Don't download this archive.\n* `{:reschedule, timeout}` - Defer making a decision. Call this function again in `timeout` milliseconds.","ref":"NervesHubLink.Client.html#c:archive_available/1","title":"NervesHubLink.Client.archive_available/1","type":"callback"},{"doc":"","ref":"NervesHubLink.Client.html#archive_ready/2","title":"NervesHubLink.Client.archive_ready/2","type":"function"},{"doc":"Called when an archive has been downloaded and is available for the application to do something","ref":"NervesHubLink.Client.html#c:archive_ready/2","title":"NervesHubLink.Client.archive_ready/2","type":"callback"},{"doc":"This function is called internally by NervesHubLink to notify clients of fwup errors.","ref":"NervesHubLink.Client.html#handle_error/1","title":"NervesHubLink.Client.handle_error/1","type":"function"},{"doc":"Called when downloading a firmware update fails.\n\nThe return value of this function is not checked.","ref":"NervesHubLink.Client.html#c:handle_error/1","title":"NervesHubLink.Client.handle_error/1","type":"callback"},{"doc":"This function is called internally by NervesHubLink to notify clients of fwup progress.","ref":"NervesHubLink.Client.html#handle_fwup_message/1","title":"NervesHubLink.Client.handle_fwup_message/1","type":"function"},{"doc":"Called on firmware update reports.\n\nThe return value of this function is not checked.","ref":"NervesHubLink.Client.html#c:handle_fwup_message/1","title":"NervesHubLink.Client.handle_fwup_message/1","type":"callback"},{"doc":"This function is called internally by NervesHubLink to identify a device.","ref":"NervesHubLink.Client.html#identify/0","title":"NervesHubLink.Client.identify/0","type":"function"},{"doc":"Callback to identify the device from NervesHub.","ref":"NervesHubLink.Client.html#c:identify/0","title":"NervesHubLink.Client.identify/0","type":"callback"},{"doc":"This function is called internally by NervesHubLink to initiate a reboot.\n\nAfter a successful firmware update, NervesHubLink calls this to start the\nreboot process. It calls `c:reboot/0` if supplied or\n`Nerves.Runtime.reboot/0`.","ref":"NervesHubLink.Client.html#initiate_reboot/0","title":"NervesHubLink.Client.initiate_reboot/0","type":"function"},{"doc":"Optional callback to reboot the device when a firmware update completes\n\nThe default behavior is to call `Nerves.Runtime.reboot/0` after a successful update. This\nis useful for testing and for doing additional work like notifying users in a UI that a reboot\nwill happen soon. It is critical that a reboot does happen.","ref":"NervesHubLink.Client.html#c:reboot/0","title":"NervesHubLink.Client.reboot/0","type":"callback"},{"doc":"This function is called internally by NervesHubLink to notify clients of disconnects.","ref":"NervesHubLink.Client.html#reconnect_backoff/0","title":"NervesHubLink.Client.reconnect_backoff/0","type":"function"},{"doc":"Optional callback when the socket disconnected, before starting to reconnect.\n\nThe return value is used to reset the next socket's retry timeout. `nil` uses\nthe default. The default is a call to `NervesHubLink.Backoff.delay_list/3`.\n\nYou may wish to use this to dynamically change the reconnect backoffs. For instance,\nduring a NervesHub deploy you may wish to change the reconnect based on your\nown logic to not create a thundering herd of reconnections. If you have a particularly\nflaky connection you can increase how fast the reconnect happens to avoid overloading\nyour server.","ref":"NervesHubLink.Client.html#c:reconnect_backoff/0","title":"NervesHubLink.Client.reconnect_backoff/0","type":"callback"},{"doc":"This function is called internally by NervesHubLink to notify clients.","ref":"NervesHubLink.Client.html#update_available/1","title":"NervesHubLink.Client.update_available/1","type":"function"},{"doc":"Called to find out what to do when a firmware update is available.\n\nMay return one of:\n\n* `apply` - Download and apply the update right now.\n* `ignore` - Don't download and apply this update.\n* `{:reschedule, timeout}` - Defer making a decision. Call this function again in `timeout` milliseconds.","ref":"NervesHubLink.Client.html#c:update_available/1","title":"NervesHubLink.Client.update_available/1","type":"callback"},{"doc":"Archive that comes over a socket.","ref":"NervesHubLink.Client.html#t:archive_data/0","title":"NervesHubLink.Client.archive_data/0","type":"type"},{"doc":"Supported responses from `archive_available/1`","ref":"NervesHubLink.Client.html#t:archive_response/0","title":"NervesHubLink.Client.archive_response/0","type":"type"},{"doc":"Firmware update progress, completion or error report","ref":"NervesHubLink.Client.html#t:fwup_message/0","title":"NervesHubLink.Client.fwup_message/0","type":"type"},{"doc":"Update that comes over a socket.","ref":"NervesHubLink.Client.html#t:update_data/0","title":"NervesHubLink.Client.update_data/0","type":"type"},{"doc":"Supported responses from `update_available/1`","ref":"NervesHubLink.Client.html#t:update_response/0","title":"NervesHubLink.Client.update_response/0","type":"type"},{"doc":"Default NervesHubLink.Client implementation\n\nThis client always accepts an update.","ref":"NervesHubLink.Client.Default.html","title":"NervesHubLink.Client.Default","type":"module"},{"doc":"","ref":"NervesHubLink.Configurator.html","title":"NervesHubLink.Configurator","type":"behaviour"},{"doc":"","ref":"NervesHubLink.Configurator.html#build/0","title":"NervesHubLink.Configurator.build/0","type":"function"},{"doc":"","ref":"NervesHubLink.Configurator.html#c:build/1","title":"NervesHubLink.Configurator.build/1","type":"callback"},{"doc":"","ref":"NervesHubLink.Configurator.html#fetch_configurator/0","title":"NervesHubLink.Configurator.fetch_configurator/0","type":"function"},{"doc":"","ref":"NervesHubLink.Configurator.Config.html","title":"NervesHubLink.Configurator.Config","type":"module"},{"doc":"","ref":"NervesHubLink.Configurator.Config.html#t:t/0","title":"NervesHubLink.Configurator.Config.t/0","type":"type"},{"doc":"","ref":"NervesHubLink.Configurator.LocalCertKey.html","title":"NervesHubLink.Configurator.LocalCertKey","type":"module"},{"doc":"","ref":"NervesHubLink.Configurator.NervesKey.html","title":"NervesHubLink.Configurator.NervesKey","type":"module"},{"doc":"","ref":"NervesHubLink.Configurator.SharedSecret.html","title":"NervesHubLink.Configurator.SharedSecret","type":"module"},{"doc":"Generate headers for Shared Secret Auth","ref":"NervesHubLink.Configurator.SharedSecret.html#headers/1","title":"NervesHubLink.Configurator.SharedSecret.headers/1","type":"function"},{"doc":"Handles downloading files via HTTP.\ninternally caches several interesting properties about\nthe download such as:\n\n  * the URI of the request\n  * the total content amounts of bytes of the file being downloaded\n  * the total amount of bytes downloaded at any given time\n\nUsing this information, it can restart a download using the\n[`Range` HTTP header](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Range).\n\nThis process's **only** focus is obtaining data reliably. It doesn't have any\nside effects on the system.","ref":"NervesHubLink.Downloader.html","title":"NervesHubLink.Downloader","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NervesHubLink.Downloader.html#child_spec/1","title":"NervesHubLink.Downloader.child_spec/1","type":"function"},{"doc":"Begins downloading a file at `url` handled by `fun`.\n\n# Example\n\n      iex> pid = self()\n      #PID<0.110.0>\n      iex> fun = fn {:data, data} -> File.write(\"index.html\", data)\n      ...> {:error, error} -> IO.puts(\"error streaming file: #{inspect(error)}\")\n      ...> :complete -> send pid, :complete\n      ...> end\n      #Function<44.97283095/1 in :erl_eval.expr/5>\n      iex> NervesHubLink.Downloader.start_download(\"https://httpbin.com/\", fun)\n      {:ok, #PID<0.111.0>}\n      iex> flush()\n      :complete","ref":"NervesHubLink.Downloader.html#start_download/2","title":"NervesHubLink.Downloader.start_download/2","type":"function"},{"doc":"","ref":"NervesHubLink.Downloader.html#start_download/3","title":"NervesHubLink.Downloader.start_download/3","type":"function"},{"doc":"","ref":"NervesHubLink.Downloader.html#t:event_handler_fun/0","title":"NervesHubLink.Downloader.event_handler_fun/0","type":"type"},{"doc":"","ref":"NervesHubLink.Downloader.html#t:handler_event/0","title":"NervesHubLink.Downloader.handler_event/0","type":"type"},{"doc":"","ref":"NervesHubLink.Downloader.html#t:initialized_download/0","title":"NervesHubLink.Downloader.initialized_download/0","type":"type"},{"doc":"","ref":"NervesHubLink.Downloader.html#t:resume_rescheduled/0","title":"NervesHubLink.Downloader.resume_rescheduled/0","type":"type"},{"doc":"","ref":"NervesHubLink.Downloader.html#t:retry_args/0","title":"NervesHubLink.Downloader.retry_args/0","type":"type"},{"doc":"","ref":"NervesHubLink.Downloader.html#t:t/0","title":"NervesHubLink.Downloader.t/0","type":"type"},{"doc":"Configuration structure for how the Downloader server will\nhandle disconnects, errors, timeouts etc","ref":"NervesHubLink.Downloader.RetryConfig.html","title":"NervesHubLink.Downloader.RetryConfig","type":"module"},{"doc":"time in milliseconds between chunks of data received\nthat once elapsed will trigger a retry. This event counts\ntowards the `max_disconnects` counter","ref":"NervesHubLink.Downloader.RetryConfig.html#t:idle_timeout/0","title":"NervesHubLink.Downloader.RetryConfig.idle_timeout/0","type":"type"},{"doc":"maximum number of disconnects. After this limit is reached\nthe download will be stopped and will no longer be retried","ref":"NervesHubLink.Downloader.RetryConfig.html#t:max_disconnects/0","title":"NervesHubLink.Downloader.RetryConfig.max_disconnects/0","type":"type"},{"doc":"maximum time in milliseconds that a download can exist for.\nafter this amount of time has elapsed, the download is canceled\nand the download process will crash","ref":"NervesHubLink.Downloader.RetryConfig.html#t:max_timeout/0","title":"NervesHubLink.Downloader.RetryConfig.max_timeout/0","type":"type"},{"doc":"","ref":"NervesHubLink.Downloader.RetryConfig.html#t:t/0","title":"NervesHubLink.Downloader.RetryConfig.t/0","type":"type"},{"doc":"time in milliseconds to wait before attempting to retry a download","ref":"NervesHubLink.Downloader.RetryConfig.html#t:time_between_retries/0","title":"NervesHubLink.Downloader.RetryConfig.time_between_retries/0","type":"type"},{"doc":"worst case download speed specified in bytes per second. This is\nused to calculate the \"worst case\" download timeout. it is meant to\nfail faster than waiting for `max_timeout` to elapse","ref":"NervesHubLink.Downloader.RetryConfig.html#t:worst_case_download_speed/0","title":"NervesHubLink.Downloader.RetryConfig.worst_case_download_speed/0","type":"type"},{"doc":"Pure functions for dealing with timeouts","ref":"NervesHubLink.Downloader.TimeoutCalculation.html","title":"NervesHubLink.Downloader.TimeoutCalculation","type":"module"},{"doc":"Calculates the worst_case_timeout value based on content_length header and worst case network speed","ref":"NervesHubLink.Downloader.TimeoutCalculation.html#calculate_worst_case_timeout/2","title":"NervesHubLink.Downloader.TimeoutCalculation.calculate_worst_case_timeout/2","type":"function"},{"doc":"","ref":"NervesHubLink.Downloader.TimeoutCalculation.html#t:bits_per_second/0","title":"NervesHubLink.Downloader.TimeoutCalculation.bits_per_second/0","type":"type"},{"doc":"","ref":"NervesHubLink.Downloader.TimeoutCalculation.html#t:number_of_bytes/0","title":"NervesHubLink.Downloader.TimeoutCalculation.number_of_bytes/0","type":"type"},{"doc":"","ref":"NervesHubLink.Extensions.html","title":"NervesHubLink.Extensions","type":"behaviour"},{"doc":"Attach specified extensions","ref":"NervesHubLink.Extensions.html#attach/1","title":"NervesHubLink.Extensions.attach/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NervesHubLink.Extensions.html#child_spec/1","title":"NervesHubLink.Extensions.child_spec/1","type":"function"},{"doc":"Detach specified extensions\n\nAlso supports `:all` as an argument for cases NervesHubLink\nmay want to detach all of them at once","ref":"NervesHubLink.Extensions.html#detach/1","title":"NervesHubLink.Extensions.detach/1","type":"function"},{"doc":"","ref":"NervesHubLink.Extensions.html#handle_event/2","title":"NervesHubLink.Extensions.handle_event/2","type":"function"},{"doc":"Invoked when routing an Extension event\n\nBehaves the same as `c:GenServer.handle_info/2`","ref":"NervesHubLink.Extensions.html#c:handle_event/3","title":"NervesHubLink.Extensions.handle_event/3","type":"callback"},{"doc":"List extensions currently available","ref":"NervesHubLink.Extensions.html#list/0","title":"NervesHubLink.Extensions.list/0","type":"function"},{"doc":"","ref":"NervesHubLink.Extensions.html#start_link/1","title":"NervesHubLink.Extensions.start_link/1","type":"function"},{"doc":"","ref":"NervesHubLink.Extensions.Geo.html","title":"NervesHubLink.Extensions.Geo","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NervesHubLink.Extensions.Geo.html#child_spec/1","title":"NervesHubLink.Extensions.Geo.child_spec/1","type":"function"},{"doc":"","ref":"NervesHubLink.Extensions.Geo.html#push/2","title":"NervesHubLink.Extensions.Geo.push/2","type":"function"},{"doc":"","ref":"NervesHubLink.Extensions.Geo.html#start_link/1","title":"NervesHubLink.Extensions.Geo.start_link/1","type":"function"},{"doc":"","ref":"NervesHubLink.Extensions.Geo.DefaultResolver.html","title":"NervesHubLink.Extensions.Geo.DefaultResolver","type":"module"},{"doc":"","ref":"NervesHubLink.Extensions.Geo.Resolver.html","title":"NervesHubLink.Extensions.Geo.Resolver","type":"behaviour"},{"doc":"","ref":"NervesHubLink.Extensions.Geo.Resolver.html#c:resolve_location/0","title":"NervesHubLink.Extensions.Geo.Resolver.resolve_location/0","type":"callback"},{"doc":"Formatted error response from a failed location resolution","ref":"NervesHubLink.Extensions.Geo.Resolver.html#t:error_information/0","title":"NervesHubLink.Extensions.Geo.Resolver.error_information/0","type":"type"},{"doc":"Location information from a successful location resolution","ref":"NervesHubLink.Extensions.Geo.Resolver.html#t:location_information/0","title":"NervesHubLink.Extensions.Geo.Resolver.location_information/0","type":"type"},{"doc":"Supported responses from `resolve_location/0`","ref":"NervesHubLink.Extensions.Geo.Resolver.html#t:location_responses/0","title":"NervesHubLink.Extensions.Geo.Resolver.location_responses/0","type":"type"},{"doc":"","ref":"NervesHubLink.Extensions.Health.html","title":"NervesHubLink.Extensions.Health","type":"module"},{"doc":"","ref":"NervesHubLink.Extensions.Health.html#check_health/1","title":"NervesHubLink.Extensions.Health.check_health/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NervesHubLink.Extensions.Health.html#child_spec/1","title":"NervesHubLink.Extensions.Health.child_spec/1","type":"function"},{"doc":"","ref":"NervesHubLink.Extensions.Health.html#push/2","title":"NervesHubLink.Extensions.Health.push/2","type":"function"},{"doc":"","ref":"NervesHubLink.Extensions.Health.html#start_link/1","title":"NervesHubLink.Extensions.Health.start_link/1","type":"function"},{"doc":"A default health report implementation with support for easily adding\nnew metadata, metrics and such via config.","ref":"NervesHubLink.Extensions.Health.DefaultReport.html","title":"NervesHubLink.Extensions.Health.DefaultReport","type":"module"},{"doc":"","ref":"NervesHubLink.Extensions.Health.DefaultReport.html#vintage_net/0","title":"NervesHubLink.Extensions.Health.DefaultReport.vintage_net/0","type":"function"},{"doc":"Structure for device status.","ref":"NervesHubLink.Extensions.Health.DeviceStatus.html","title":"NervesHubLink.Extensions.Health.DeviceStatus","type":"module"},{"doc":"","ref":"NervesHubLink.Extensions.Health.DeviceStatus.html#new/1","title":"NervesHubLink.Extensions.Health.DeviceStatus.new/1","type":"function"},{"doc":"","ref":"NervesHubLink.Extensions.Health.DeviceStatus.html#t:alarm_description/0","title":"NervesHubLink.Extensions.Health.DeviceStatus.alarm_description/0","type":"type"},{"doc":"","ref":"NervesHubLink.Extensions.Health.DeviceStatus.html#t:alarm_id/0","title":"NervesHubLink.Extensions.Health.DeviceStatus.alarm_id/0","type":"type"},{"doc":"","ref":"NervesHubLink.Extensions.Health.DeviceStatus.html#t:connection_status/0","title":"NervesHubLink.Extensions.Health.DeviceStatus.connection_status/0","type":"type"},{"doc":"","ref":"NervesHubLink.Extensions.Health.DeviceStatus.html#t:interface_identifer/0","title":"NervesHubLink.Extensions.Health.DeviceStatus.interface_identifer/0","type":"type"},{"doc":"","ref":"NervesHubLink.Extensions.Health.DeviceStatus.html#t:interface_type/0","title":"NervesHubLink.Extensions.Health.DeviceStatus.interface_type/0","type":"type"},{"doc":"","ref":"NervesHubLink.Extensions.Health.DeviceStatus.html#t:t/0","title":"NervesHubLink.Extensions.Health.DeviceStatus.t/0","type":"type"},{"doc":"","ref":"NervesHubLink.Extensions.Health.Report.html","title":"NervesHubLink.Extensions.Health.Report","type":"behaviour"},{"doc":"","ref":"NervesHubLink.Extensions.Health.Report.html#c:alarms/0","title":"NervesHubLink.Extensions.Health.Report.alarms/0","type":"callback"},{"doc":"","ref":"NervesHubLink.Extensions.Health.Report.html#c:checks/0","title":"NervesHubLink.Extensions.Health.Report.checks/0","type":"callback"},{"doc":"","ref":"NervesHubLink.Extensions.Health.Report.html#c:connectivity/0","title":"NervesHubLink.Extensions.Health.Report.connectivity/0","type":"callback"},{"doc":"","ref":"NervesHubLink.Extensions.Health.Report.html#c:metadata/0","title":"NervesHubLink.Extensions.Health.Report.metadata/0","type":"callback"},{"doc":"","ref":"NervesHubLink.Extensions.Health.Report.html#c:metrics/0","title":"NervesHubLink.Extensions.Health.Report.metrics/0","type":"callback"},{"doc":"","ref":"NervesHubLink.Extensions.Health.Report.html#c:timestamp/0","title":"NervesHubLink.Extensions.Health.Report.timestamp/0","type":"callback"},{"doc":"Config structure responsible for handling callbacks from FWUP,\napplying a fwupdate, and storing fwup task configuration","ref":"NervesHubLink.FwupConfig.html","title":"NervesHubLink.FwupConfig","type":"module"},{"doc":"Raises an ArgumentError on invalid arguments","ref":"NervesHubLink.FwupConfig.html#validate!/1","title":"NervesHubLink.FwupConfig.validate!/1","type":"function"},{"doc":"`handle_fwup_message` will be called with this data","ref":"NervesHubLink.FwupConfig.html#t:fwup_message/0","title":"NervesHubLink.FwupConfig.fwup_message/0","type":"type"},{"doc":"Callback that will be called during the lifecycle of a fwupdate being applied","ref":"NervesHubLink.FwupConfig.html#t:handle_fwup_message_fun/0","title":"NervesHubLink.FwupConfig.handle_fwup_message_fun/0","type":"type"},{"doc":"","ref":"NervesHubLink.FwupConfig.html#t:t/0","title":"NervesHubLink.FwupConfig.t/0","type":"type"},{"doc":"Called when an update has been dispatched via `NervesHubLink.UpdateManager.apply_update/2`","ref":"NervesHubLink.FwupConfig.html#t:update_available_fun/0","title":"NervesHubLink.FwupConfig.update_available_fun/0","type":"type"},{"doc":"Structure containing metadata about a firmware.","ref":"NervesHubLink.Message.FirmwareMetadata.html","title":"NervesHubLink.Message.FirmwareMetadata","type":"module"},{"doc":"","ref":"NervesHubLink.Message.FirmwareMetadata.html#parse/1","title":"NervesHubLink.Message.FirmwareMetadata.parse/1","type":"function"},{"doc":"","ref":"NervesHubLink.Message.FirmwareMetadata.html#t:t/0","title":"NervesHubLink.Message.FirmwareMetadata.t/0","type":"type"},{"doc":"","ref":"NervesHubLink.Script.html","title":"NervesHubLink.Script","type":"module"},{"doc":"Run a script from NervesHub and capture its output","ref":"NervesHubLink.Script.html#capture/2","title":"NervesHubLink.Script.capture/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NervesHubLink.Script.html#child_spec/1","title":"NervesHubLink.Script.child_spec/1","type":"function"},{"doc":"GenServer responsible for brokering messages between:\n  * an external controlling process\n  * FWUP\n  * HTTP\n\nShould be started in a supervision tree","ref":"NervesHubLink.UpdateManager.html","title":"NervesHubLink.UpdateManager","type":"module"},{"doc":"Must be called when an update payload is dispatched from\nNervesHub. the map must contain a `\"firmware_url\"` key.","ref":"NervesHubLink.UpdateManager.html#apply_update/3","title":"NervesHubLink.UpdateManager.apply_update/3","type":"function"},{"doc":"Returns the UUID of the currently downloading firmware, or nil.","ref":"NervesHubLink.UpdateManager.html#currently_downloading_uuid/1","title":"NervesHubLink.UpdateManager.currently_downloading_uuid/1","type":"function"},{"doc":"Returns the current status of the update manager","ref":"NervesHubLink.UpdateManager.html#status/1","title":"NervesHubLink.UpdateManager.status/1","type":"function"},{"doc":"Structure for the state of the `UpdateManager` server.\nContains types that describe status and different states the\n`UpdateManager` can be in","ref":"NervesHubLink.UpdateManager.State.html","title":"NervesHubLink.UpdateManager.State","type":"module"},{"doc":"","ref":"NervesHubLink.UpdateManager.State.html#t:status/0","title":"NervesHubLink.UpdateManager.State.status/0","type":"type"},{"doc":"","ref":"NervesHubLink.UpdateManager.State.html#t:t/0","title":"NervesHubLink.UpdateManager.State.t/0","type":"type"},{"doc":"","ref":"NervesHubLink.UploadFile.State.html","title":"NervesHubLink.UploadFile.State","type":"module"},{"doc":"","ref":"NervesHubLink.UploadFile.State.html#t:t/0","title":"NervesHubLink.UploadFile.State.t/0","type":"type"},{"doc":"# NervesHubLink\n\n[![CircleCI](https://circleci.com/gh/nerves-hub/nerves_hub_link/tree/main.svg?style=svg)](https://circleci.com/gh/nerves-hub/nerves_hub_link/tree/main)\n[![Hex version](https://img.shields.io/hexpm/v/nerves_hub_link.svg \"Hex version\")](https://hex.pm/packages/nerves_hub_link)\n\nThe Device-side client library for NervesHub.\n\nThis is the 2.x version NervesHubLink. If you have been using NervesHub prior to around April, 2023 and have not updated to 2.0 or newer see the `maint-v1` branch.\n\n---","ref":"readme.html","title":"NervesHubLink","type":"extras"},{"doc":"[NervesHub](https://www.nerves-hub.org/) is an open-source IoT fleet management server that is built specifically for Nerves-based devices.\n\nDevices connect to the server by joining a long-lived Phoenix channel (for HTTP polling, see [nerves_hub_link_http](https://github.com/nerves-hub/nerves_hub_link_http)). If a firmware update is available, NervesHub will provide a URL to the device and the device can update immediately or [when convenient](https://github.com/nerves-hub/nerves_hub_link#conditionally-applying-updates).\n\nNervesHub does impose some requirements on devices and firmware that may require changes to your Nerves projects:\n\n- Firmware images are cryptographically signed (both NervesHub and devices validate signatures)\n- Devices are identified by a unique serial number\n\nWhen using client certificate authentication, each device will also require its own SSL certificate for authentication with NervesHub.\n\nThese changes enable NervesHub to provide assurances that the firmware you intend to install on a set of devices make it to those devices unaltered.","ref":"readme.html#overview","title":"Overview - NervesHubLink","type":"extras"},{"doc":"The following sections will walk you through updating your Nerves project to work with a NervesHub server.\n\nMany of the steps below can be automated by NervesHub users to set up automatic firmware updates from CI and to manufacture large numbers of devices.","ref":"readme.html#getting-started","title":"Getting started - NervesHubLink","type":"extras"},{"doc":"The first step is to add `nerves_hub_link` to your target dependencies in your\nproject's `mix.exs`. For example:\n\n```elixir\n  defp deps(target) do\n    [\n      {:nerves_runtime, \"~> 0.13\"},\n      {:nerves_hub_link, \"~> 2.2\"},\n      ...\n    ] ++ system(target)\n  end\n```","ref":"readme.html#adding-nerveshublink-to-your-project","title":"Adding NervesHubLink to your project - NervesHubLink","type":"extras"},{"doc":"#### Shared secret device authentication\n\n_Important: Shared Secret authentication is a new feature under active development._\n\nShared Secrets use [HMAC](https://en.wikipedia.org/wiki/HMAC) cryptography to generate an authentication token used during websocket connection.\n\nThis has been built with simple device registration in mind, an ideal fit for hobby projects or projects under early R&D.\n\nYou can generate a key and secret in your NervesHub Product settings which you then include in your `NervesHubLink` settings.\n\nA full example config:\n\n```elixir\nconfig :nerves_hub_link,\n  host: \"your.nerveshub.host\",\n  shared_secret: [\n    product_key: \" \",\n    product_secret: \" \",\n  ]\n```\n\n#### NervesKey (with cert based auth)\n\n_Important: This is recommended for production device fleets._\n\nIf your project is using [NervesKey](https://github.com/nerves-hub/nerves_key), you can tell `NervesHubLink` to read those certificates and key from the chip and assign the SSL options for you by adding it as a dependency:\n\n```elixir\ndef deps() do\n  [\n    {:nerves_key, \"~> 1.2\"}\n  ]\nend\n```\n\nThis allows your config to be simplified to:\n\n```elixir\nconfig :nerves_hub_link,\n  host: \"your.nerveshub.host\"\n```\n\nNervesKey will default to using I2C bus 1 and the `:primary` certificate pair (`:primary` is one-time configurable and `:aux` may be updated). You can customize these options to use a different bus and certificate pair:\n\n```elixir\nconfig :nerves_hub_link, :nerves_key,\n  certificate_pair: :aux,\n  i2c_bus: 0\n```\n\n#### Certificate device authentication\n\nIf you would like to use certificate device authentication, but you are not using `NervesKey`, you can tell `NervesHubLink` to read the certificate and key from the file system by using:\n\n```elixir\nconfig :nerves_hub_link,\n  host: \"your.nerveshub.host\",\n  configurator: NervesHubLink.Configurator.LocalCertKey\n```\n\nBy default the configurator will use a certificate found at `/data/nerves_hub/cert.pem` and a key found at `/data/nerves_hub/key.pem`. If these are stored somewhere differently then you can specify `certfile` and `keyfile` in the `ssl` config, e.g.:\n\n```elixir\nconfig :nerves_hub_link,\n  host: \"your.nerveshub.host\",\n  configurator: NervesHubLink.Configurator.LocalCertKey,\n  ssl: [\n    certfile: \"/path/to/certfile.pem\",\n    keyfile: \"/path/to/keyfile.key\"\n  ]\n```\n\nFor more information on how to generate device certificates, please read the [\"Initializing devices\"](#https://github.com/nerves-hub/nerves_hub_cli#initializing-devices) section in the `NervesHubCLI` readme.\n\n#### Additional notes\n\nAny [valid Erlang ssl socket option](http://erlang.org/doc/man/ssl.html#TLS/DTLS%20OPTION%20DESCRIPTIONS%20-%20COMMON%20for%20SERVER%20and%20CLIENT) can go in the `:ssl` key. These options are passed to [Mint](https://hex.pm/packages/mint) by [Slipstream](https://hex.pm/packages/slipstream), which `NervesHubLink` uses for websocket connections.","ref":"readme.html#connecting-your-device-to-nerveshub","title":"Connecting your device to NervesHub - NervesHubLink","type":"extras"},{"doc":"`NervesHubLink` also supports runtime configuration via the `NervesHubLink.Configurator` behavior. This is called during application startup to build the configuration that is to be used for the connection. When implementing the behavior, you'll receive the initial default config read in from the application environment and you can modify it however you need.\n\nThis is useful for cases like:\n\n- selectively choosing which cert/key to use\n- reading a certificate file stored on the device which isn't available during compilation\n\nFor example:\n\n```elixir\ndefmodule MyApp.Configurator do\n  @behaviour NervesHubLink.Configurator\n\n  @impl NervesHubLink.Configurator\n  def build(config) do\n    ssl = [certfile: \"/root/ssl/cert.pem\", keyfile: \"/root/ssl/key.pem\"]\n    %{config | ssl: ssl}\n  end\nend\n```\n\nThen you specify which configurator `NervesHubLink` should use in `config.exs`:\n\n```elixir\nconfig :nerves_hub_link, configurator: MyApp.Configurator\n```","ref":"readme.html#runtime-configuration","title":"Runtime configuration - NervesHubLink","type":"extras"},{"doc":"","ref":"readme.html#advanced-extensions","title":"Advanced extensions - NervesHubLink","type":"extras"},{"doc":"It's not always appropriate to apply a firmware update immediately. Custom logic can be added to the device by implementing the `NervesHubLink.Client` behaviour and telling the NervesHubLink OTP application about it.\n\nHere's an example implementation:\n\n```elixir\ndefmodule MyApp.NervesHubLinkClient do\n   @behaviour NervesHubLink.Client\n\n   # May return:\n   #  * `:apply` - apply the action immediately\n   #  * `:ignore` - don't apply the action, don't ask again.\n   #  * `{:reschedule, timeout_in_milliseconds}` - call this function again later.\n\n   @impl NervesHubLink.Client\n   def update_available(data) do\n    if SomeInternalAPI.is_now_a_good_time_to_update?(data) do\n      :apply\n    else\n      {:reschedule, 60_000}\n    end\n   end\nend\n```\n\nTo have NervesHubLink invoke it, update your `config.exs` as follows:\n\n```elixir\nconfig :nerves_hub_link, client: MyApp.NervesHubLinkClient\n```","ref":"readme.html#conditionally-applying-updates","title":"Conditionally applying updates - NervesHubLink","type":"extras"},{"doc":"See the previous section for implementing a `client` behaviour.\n\n```elixir\ndefmodule MyApp.NervesHubLinkClient do\n  @behaviour NervesHubLink.Client\n  #  argument can be:\n  #   {:ok, non_neg_integer(), String.t()}\n  #   {:warning, non_neg_integer(), String.t()}\n  #   {:error, non_neg_integer(), String.t()}\n  #   {:progress, 0..100}\n  def handle_fwup_message({:ok, _, _}) do\n    Logger.error(\"Firmware update complete\")\n    :ok\n  end\n\n  def handle_fwup_message({:warning, code, message}) do\n    Logger.error(\"Warning while applying firmware update (#{code)}): #{message}\")\n    :ok\n  end\n\n  def handle_fwup_message({:error, _, message}) do\n    Logger.error(\"Error while applying firmware update #(#{code}): {message}\")\n    :ok\n  end\n\n  def handle_fwup_message({:progress, progress}) when rem(progress, 10) do\n    Logger.info(\"Update progress: #{progress}%\")\n    :ok\n  end\n\n  def handle_fwup_message({:progress, _}) do\n    :ok\n  end\nend\n```","ref":"readme.html#reporting-update-progress","title":"Reporting update progress - NervesHubLink","type":"extras"},{"doc":"It's possible to remotely log into your device via the NervesHub web interface. This feature is disabled by default. To enable, add the following to your `config.exs`:\n\n```elixir\nconfig :nerves_hub_link, remote_iex: true\n```\n\nThe remote IEx process is started on the first data request from NervesHub and is terminated after 5 minutes of inactivity. You can adjust this by setting `:remote_iex_timeout` value in seconds in your `config.exs`:\n\n```elixir\nconfig :nerves_hub_link, remote_iex_timeout: 900 # 15 minutes\n```\n\nYou may also need additional permissions on NervesHub to see the device and to use the remote IEx feature.","ref":"readme.html#enabling-remote-iex-access","title":"Enabling remote IEx access - NervesHubLink","type":"extras"},{"doc":"This application can set and clear the following alarms:\n\n- `NervesHubLink.Disconnected`\n  - set: An issue is preventing a connection to NervesHub or one just hasn't been made yet\n  - clear: Currently connected to NervesHub\n- `NervesHubLink.UpdateInProgress`\n  - set: A new firmware update is being downloaded or applied\n  - clear: No updates are happening","ref":"readme.html#alarms","title":"Alarms - NervesHubLink","type":"extras"},{"doc":"The CA certificates installed on the device are used by default.\n\nIf you include the [CAStore](https://hex.pm/packages/castore) in your project, then that will be selected and used.\n\nOtherwise you can configure `nerves_hub_link` to use custom CA certificates, which is useful if you are running your own NervesHub instance with self signed SSL certificates. Use the `:ca_store` option to specify a module with a `ca_certs/0` function that returns a list of DER encoded certificates:\n\n```elixir\nconfig :nerves_hub_link, ca_store: MyModule\n```\n\nOr if you have the certificates in DER format, you can also explicitly set them in the :ssl option:\n\n```elixir\nmy_der_list = [<<213, 34, 234, 53, 83, 8, 2, ...>>]\nconfig :nerves_hub_link, ssl: [cacerts: my_der_list]\n```","ref":"readme.html#ca-certificates","title":"CA Certificates - NervesHubLink","type":"extras"},{"doc":"`NervesHubLink` will attempt to verify that the network is available before initiating the first connection attempt. This is done by checking if the `NervesHub` host address (`config.host`) can be resolved. If the network isn't available then the check will be run again in 2 seconds.\n\nYou can disable this behaviour with the following config:\n\n```elixir\nconfig :nerves_hub_link, connect_wait_for_network: false\n```","ref":"readme.html#verifying-network-availability","title":"Verifying network availability - NervesHubLink","type":"extras"},{"doc":"To disable `NervesHubLink` connecting to `NervesHub` when testing, you can add:\n\n```elixir\nconfig :nerves_hub_link, connect: false\n```\n\nto your `config/test.exs`","ref":"readme.html#disable-nerveshublink-during-testing","title":"Disable `NervesHubLink` during testing - NervesHubLink","type":"extras"},{"doc":"Extensions are pieces of non-critical functionality going over the NervesHub WebSocket. They are separated out under the Extensions mechanism so that the client can happily ignore anything extension-related in service of keeping firmware updates healthy. That is always the top priority.\n\nThere are two extensions currently:\n\n- **Health** reports device metrics, alarms, metadata and similar.\n- **Geo** provides GeoIP information and allows slotting in a better source.\n\nYour NervesHub server controls enabling and disabling extensions to allow you to switch them off if they impact operations.","ref":"readme.html#extensions-health-geo","title":"Extensions: Health & Geo - NervesHubLink","type":"extras"},{"doc":"You can add your own metrics, metadata and alarms:\n\nIn your config.exs for the device:\n\n```\nconfig :nerves_hub_link,\n  health: [\n    # metrics are added with a key and MFA\n    # the function should return a number (int or float is fine)\n    metrics: %{\n      \"cats_passed\" => {CatCounter, :total, []}\n    },\n\n    # metadata is identical but should return a string\n    metrics: %{\n      \"placement\" => {CatCounter, :venue, []}\n    }\n  ]\n```\n\nOr you can implement a completely custom reporting module by implementing `NervesHubLink.Extensions.Health.Report` and configuring it:\n\n```\nconfig :nerves_hub_link,\n  health: [\n    report: CatCounter.MyHealthReport\n  ]\n```","ref":"readme.html#configure-health","title":"Configure Health - NervesHubLink","type":"extras"},{"doc":"It is intended to be easy to replace the default Geo Resolver with your own. Maybe you have a GPS module or can resolve a reasonably precise location via LTE. Just change config:\n\n```\nconfig :nerves_hub_link,\n  geo: [\n    resolver: CatCounter.MyResolver\n  ]\n```\n\nYour module only needs to implement a single function, see `NervesHubLink.Extensions.Geo.Resolver` for details.","ref":"readme.html#configure-geo","title":"Configure Geo - NervesHubLink","type":"extras"},{"doc":"NervesHubLink will automatically report Erlang Alarms from `:alarm_handler` IF you have added a custom alarm handler. The default one is not very helpful and not intended for production use from what I gather. One well-used option is [`alarmist`](https://hex.pm/packages/alarmist).","ref":"readme.html#configure-alarms","title":"Configure Alarms - NervesHubLink","type":"extras"},{"doc":"","ref":"readme.html#debugging-errors","title":"Debugging errors - NervesHubLink","type":"extras"},{"doc":"If you see the following in your logs:\n\n```text\n14:26:06.926 [info]  ['TLS', 32, 'client', 58, 32, 73, 110, 32, 115, 116, 97, 116, 101, 32, 'cipher', 32, 'received SERVER ALERT: Fatal - Unknown CA', 10]\n```\n\nThis probably indicates that the signing certificate hasn't been uploaded to NervesHub so the device can't be authenticated. Double check that you ran:\n\n```sh\nmix nerves_hub.ca_certificate register my-signer.cert\n```\n\nAnother possibility is that the device wasn't provisioned with the certificate\nthat's on NervesHub.\n\nSee also [NervesHubWeb: Potential SSL Issues](https://github.com/nerves-hub/nerves_hub_web#potential-ssl-issues)","ref":"readme.html#tls-client-errors","title":"TLS client errors - NervesHubLink","type":"extras"},{"doc":"`NervesHubLink.Configurator` includes two internal versions for NervesHub to determine what extensions are available on the device socket.\n\n### `device_api_version`\n\n- `1.0.0` - Updating firmware, status updates, reboot device\n- `2.0.0` - Identify a device, archives\n- `2.1.0` - Run scripts on a device separate from the console, sync firmware keys and archive keys\n- `2.2.0` - Report what extensions are enabled and their version\n\n### `console_version`\n\n- `1.0.0` - Remote IEx console\n- `2.0.0` - Send and receive files from a device","ref":"readme.html#internal-api-versions","title":"Internal API Versions - NervesHubLink","type":"extras"},{"doc":"# Changelog\n\n## [2.6.0] - 2024-12-03\n\nThis update includes Extensions, a mechanism to handle extensions on a device\nfor custom data and/or reporting outside the firmware update mechanism. These\nare isolated from the socket as to not get in the way of potential firmware\nupdates and can be defined in external libs as well as this one by implementing\nthe `NervesHubLink.Extensions` behavior. Extensions are controlled by NervesHub\nand can be adjusted at the product or device level for granular control.\n\n* Added\n  * Add support for Extensions using the Socket (#228)\n    * Initial extensions supported are `NervesHubLink.Extensions.Health` and\n      `NervesHubLink.Extensions.Geo`\n\n* Updated\n  * Bump device_api_version to 2.2.0; check README for details (#255)\n\n## [2.5.2] - 2024-10-09\n\n* Updated\n  * Change to only configure if connecting (#229)\n\n## [2.5.1] - 2024-08-09\n\n* Updated\n  * Fix issue causing shared secret authentications to fail until Erlang is able\n    to catch the system time up. (#225)\n\n## [2.5.0] - 2024-07-14\n\nThis latest release requires Elixir 1.13 or later.\n\n* Added\n  * Run a NervesHub script on device (#207)\n* Updated\n  * Simplify connection settings (#214)\n\n## [2.4.0] - 2024-06-24\n\n* Added\n  * Configure heartbeat msec (#197)\n  * Apply backpressure to downloader on slow updates (#202)\n* Updated\n  * Fix no match error when uploading files (#190)\n  * Make shared secret auth the default (#176)\n  * Archive public keys can default to fwup public keys if not configured (#187)\n\n## [2.3.0] - 2024-05-11\n\n* Added\n  * check for network connectivity before connecting (#181)\n* Updated\n  * Log unknown messages from NervesHub\n  * Clearer and more consistent logging\n\n## [2.2.1] - 2024-04-19\n\n* Added\n  * New alarms via Erlang [`alarm_handler`](https://www.erlang.org/doc/man/alarm_handler)\n  that can be monitored directly or via libraries such as [`:alarmist`](https://hex.pm/packages/alarmist)\n    * `NervesHubLink.Disconnected`\n    * `NervesHubLink.UpdateInProgress`\n  * [NervesTime](https://hex.pm/packages/nerves_time) has been added as a dependency.\n  * Download current firmware public keys on device connection. If no public firmware signing keys are defined in your config, NervesHubLink will request them from NervesHub when establishing a connection.\n\n* Updated\n  * `:public_key` CA certificates are used by default. If [CAStore](https://hex.pm/packages/castore) is included in your project it will be preferred.\n\n## [2.2.0] - 2024-03-18\n\nThis update includes Archives, which is an extra fwup file that is downloaded as part\nof a deployment. This allows you to send an update for something smaller than the whole\nfirmware. Archives are validated with separate public keys for safety.\n\n* Added\n  * Archive downloading and processing for extra packages\n\n## [2.1.1] - 2024-02-05\n\n* Fixed\n  * `UploadFile` stream changed to be backwards compatible with Elixir 1.16 and older\n\n## [2.1.0] - 2024-02-05\n\nThis update should be relatively safe and backwards compatible. It introduces some\nnew features with NervesHub including Pre-shared key authentication and file\nupload/download ability through the console channge. If you were previously\nrelying on `NervesHubLink.Connection` functions then you will need to review\nand update your code to use `NervesHubLink` connection functions instead.\n\n* Removed\n  * `NervesHubLink.Connection` was removed in favor is using the connection\n    state of the socket instead.\n\n* Added\n  * Use the console channel to save files to the device (#131)\n  * Send a file to an attached NervesHub web console (#130)\n  * Pre-shared key authentication as an alternative to certificate authentication\n\n* Updated\n  * Default SNI from host if none specified\n  * Default to CAStore when no `:ca_certs` are provided\n\n## [2.0.0] - 2023-08-22\n\nThe new release of NervesHubLink starts adding new features from NervesHub 2.0, such as identifying the device you have open in NervesHub and hooks to help prevent a thundering herd of device reconnects. It also cleans up the code base a bit by removing unused packages. Make sure to run mix deps.unlock --unused after updating to keep your lock file up to date.\n\n* Removed\n  * NervesHubCLI and NervesHubCAStore as dependencies\n  * NervesHubLinkCommon as dependencies, it was merged into this repo\n\n* Added\n  * Identify callback from NervesHub, a new message from the server that\n    will let you blink an LED or anything else that will help you identify\n    the device you're looking at is the one you have open in NervesHub.\n  * Add a client callback for changing the backoff timeouts on reconnects\n    (#128)\n\n## [1.4.1] - 2023-05-26\n\n* Added\n  * Expose `NervesHubLink.console_active?` for checking active IEx sessions (#123)\n  * Improvements for Elixir 1.15 and OTP 26\n\n* Fixed\n  * Stops IEx process with `:normal` instead of causing a crash (#121)\n\n## [1.4.0] - 2022-10-07\n\n* Fixed\n  * Default to TLS 1.2 for all connections. This fixes issues if TLS 1.3 is\n    used or attempted. See [NervesHubWeb: Potential SSL Issues](https://github.com/nerves-hub/nerves_hub_web#potential-ssl-issues)\n    for more information.\n\n## [1.3.0] - 2022-09-06\n\n* Fixed\n  * Use `Slipstream.push/5` for safe publishing\n  * Don't apply update by default if the UUID is the same\n\n## [1.2.0] - 2022-05-13\n\n* `:nerves_hub_link_common 0.4.0`\n\n* Removed\n  * Elixir 1.10 is no longer supported. This matches the minimum version of\n    `nerves_hub_link_common` which is Elixir 1.11\n\n* Fixed\n  * Allow for `:slipstream ~> 1.0`\n\n## [1.1.0] - 2021-12-09\n\n* Removed\n  * Elixir 1.8 and 1.9 are no longer supported. These hadn't been tested on CI\n    and were removed when we started testing Elixir 1.13.\n\n* Added\n  * Retry timeouts are now being set on Slipstream via the\n    `:reconnect_after_msec` parameter.  The timeouts start at 1 second and\n    double up to 60 seconds plus a random amount of jitter. Previously the\n    timeouts started under a second and maxed out at 5 seconds without jitter.\n    These timeouts were chosen to reduce the load on NervesHub servers when\n    large numbers of devices disconnect. They can be overridden.\n\n## [1.0.1] - 2021-11-16\n\n* Fixed\n  * A crash in the remote console would occur if a window resize message was received\n    before the IEx process was started\n\n## [1.0.0] - 2021-10-25\n\nThis release only bumps the version number. It doesn't have any code changes.\n\n## [0.13.1] - 2021-10-19\n\n* Fixed\n  * `NervesHubLink.reconnect/0` no longer times out and instead disconnects\n    the socket forcing the reconnection logic\n\n## [0.13.0] - 2021-10-01","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"* Added\n  * Switch the websocket client to the [Slipstream](https://github.com/NFIBrokerage/slipstream)\n    library for communication with NervesHub. There are no API changes. This should only be\n    a change to the internals, but you may notice timing differences especially around retries.\n\n## [0.12.1] - 2021-08-19\n\n* Added\n  * `NervesHubLink.reconnect/0` to force reconnection of the socket and channels","ref":"changelog.html#potentially-breaking","title":"Potentially Breaking - Changelog","type":"extras"},{"doc":"* fwup 1.0.0\n\n* Enhancements\n  * added `:fwup_env` option to the Configurator to support\n    environment variables which are needed in `fwup`","ref":"changelog.html#0-12-0","title":"0.12.0 - Changelog","type":"extras"},{"doc":"* Breaking Changes\n  * This release includes a change to how CA certificates are used in the connection\n    to NervesHub. If you are connecting to the publicly hosted https://nerves-hub.org,\n    then no changes are required.\n    If you are manually supplying `:ca_certs` config value to connect to another instance\n    of NervesHub, then you will need to update you config following the instructions of\n    [CA Certificates](https://hexdocs.pm/nerves_hub_link/readme.html#ca-certificates) in the README.","ref":"changelog.html#0-11-0","title":"0.11.0 - Changelog","type":"extras"},{"doc":"* Fixes\n  * Fix issue that allowed unresolved atom keys in `:fwup_public_keys`\n    config which would break firmware updates by failing to validate\n    the public key\n  * Add missing dependency on `:inets`","ref":"changelog.html#0-10-2","title":"0.10.2 - Changelog","type":"extras"},{"doc":"* Fixes\n  * Fix typo that would cause the device to fail to reboot after applying\n    an update","ref":"changelog.html#0-10-1","title":"0.10.1 - Changelog","type":"extras"},{"doc":"* `nerves_hub_link_common 0.2.0`\n\n* Potential Breaking Changes\n  * This enforces the update data structure exchanged between device and server\n    and is mostly internal. However, if you implement your own `NervesHubLink.Client`\n    behavior, then you will need to your `NervesHubLink.Client.update_available/1` to\n    accept a `%NervesHubLink.Message.UpdateInfo{}` struct as the parameter\n    instead of a map with string keys which was used until this point.\n\n* Enhancements\n  * Report API version to NervesHub. While there's currently only one version of\n    the Device API, this is anticipation that we may want to change it in the future.\n  * On reconnect, notify NervesHub of firmware currently being downloaded so\n    that NervesHub can differentiate failed firmware updates from network hiccups.\n  * Allow devices to implement their own reboot logic by implementing the\n    `NervesHubLink.Client.reboot/0` callback\n\n* Fixes\n  * Check `firmware_url` is valid before attempting update","ref":"changelog.html#0-10-0","title":"0.10.0 - Changelog","type":"extras"},{"doc":"* Enhancements\n  * Supports resuming failed downloads by offloading the responsibility of downloading\n  and applying updates to a new package: `nerves_hub_link_common`","ref":"changelog.html#0-9-4","title":"0.9.4 - Changelog","type":"extras"},{"doc":"* Fixes\n  * Fixes misleading default error message report\n  * Ensures `:nerves_key` is started before use to deal with optional dependency\n  start order bug","ref":"changelog.html#v0-9-3","title":"v0.9.3 - Changelog","type":"extras"},{"doc":"* Enhancements\n  * Supports incoming `window_size` message from web channel to change the TTY size","ref":"changelog.html#v0-9-2","title":"v0.9.2 - Changelog","type":"extras"},{"doc":"* Enhancements\n  * Send fwup version to server when connecting. This is required If you are using patchable firmware updates.","ref":"changelog.html#v0-9-1","title":"v0.9.1 - Changelog","type":"extras"},{"doc":"This release supports the new NervesHub console terminal. After upgrading,\nremote sessions should look almost the same as `ssh`-based ones: tab-completion,\ncolors, and commandline history work as expected now.","ref":"changelog.html#v0-9-0","title":"v0.9.0 - Changelog","type":"extras"},{"doc":"* Bug Fixes\n  * Fixes a broken call to `handle_fwup_message` on fwup success (thanks @bmteller! :heart:)","ref":"changelog.html#v0-8-2","title":"v0.8.2 - Changelog","type":"extras"},{"doc":"* Enhancements\n  * Flatten console data being sent to NervesHub\n  * Log all fwup progress percentage messages","ref":"changelog.html#v0-8-1","title":"v0.8.1 - Changelog","type":"extras"},{"doc":"* `nerves_hub_cli -> 0.10.0` - This decouples the CLI from the deprecated `:nerves_hub`\nlib and frees this lib to do the same. If you are setting `:nerves_hub, org: org` in\nyour config, compilation will fail until you change it to use this lib key:\n\n```elixir\nconfig :nerves_hub_link, org: org\n```\n* `nerves_hub_user_api -> 0.6.0`\n\n* Enhancements\n  * Updates example app\n  * Cleanup and structural changes\n  * The default NervesHub certificates are no longer stored in the `priv` directory so\n  if you're not using them, they won't be included.\n\n* Fixes\n  * Fixes an issue where a device may get an update message from the server while\n  performing an update which would cause things to crash.\n  * decouples `:nerves_hub` config values - see note above","ref":"changelog.html#v0-8-0","title":"v0.8.0 - Changelog","type":"extras"},{"doc":"Various cleanup and structure changes\n\n* Enhancements\n  * Add `Configurator` behavior - Gives the user a chance to do some configuration at runtime\n  * `:nerves_key` as optional dep","ref":"changelog.html#v0-7-6","title":"v0.7.6 - Changelog","type":"extras"},{"doc":"* Bug fixes\n  * Check NervesKey is provisioned before attempting to use it","ref":"changelog.html#v0-7-5","title":"v0.7.5 - Changelog","type":"extras"},{"doc":"* Enhancements\n  * Rename to `NervesHubDevice`\n  * Remove `HTTP` support to use channels exclusively\n  * Reorganize as a an `Application` and remove ability to start a supervisor separately\n  * Support using `NervesKey` via a configuartion flag","ref":"changelog.html#v0-7-4","title":"v0.7.4 - Changelog","type":"extras"},{"doc":"* Bug fixes\n  * Fix a NervesHub remote console issue due to missing `:io_request` handling\n\n* Enhancements\n  * Add support for querying the NervesHub connection state so that this is\n    easier to plug into Erlang's heart callback. This makes it possible to have\n    a device automatically reboot if it can't reach NervesHub for a long\n    time as a last ditch attempt at recovery. This has to be hooked up.","ref":"changelog.html#v0-7-3","title":"v0.7.3 - Changelog","type":"extras"},{"doc":"* Enhancements\n  * Report firmware update progress so it can be monitored on NervesHub.","ref":"changelog.html#v0-7-2","title":"v0.7.2 - Changelog","type":"extras"},{"doc":"* Bug fixes\n  * Handle firmware download connection timeout to fail more quickly when\n    connections fail","ref":"changelog.html#v0-7-1","title":"v0.7.1 - Changelog","type":"extras"},{"doc":"* New features\n  * Support remote IEx access from authorized NervesHub users, but only if\n    enabled. To enable, add `config :nerves_hub, remote_iex: true` to your\n    `config.exs`","ref":"changelog.html#v0-7-0","title":"v0.7.0 - Changelog","type":"extras"},{"doc":"* New features\n  * Support remote reboot request from NervesHub\n\n* Bug fixes\n  * Fix decoding of private key from KV","ref":"changelog.html#v0-6-0","title":"v0.6.0 - Changelog","type":"extras"},{"doc":"* Bug fixes\n  * Increased download hang timeout to deal with slow networks and <1 minute\n    long hiccups\n  * Fixed naming collision with a named process","ref":"changelog.html#v0-5-1","title":"v0.5.1 - Changelog","type":"extras"},{"doc":"* Enhancements\n  * nerves_hub_cli: Bump to v0.7.0\n  * The Phoenix Channel connection no longer uses the topic `firmware:firmware_uuid`\n    and instead connects to the topic `device`.","ref":"changelog.html#v0-5-0","title":"v0.5.0 - Changelog","type":"extras"},{"doc":"This release has backwards incompatible changes so please read carefully.\n\nThe configuration key for firmware signing keys has changed from `:public_keys`\nto `:fwup_public_keys`.\n\nIf you are not using nerves-hub.org for your NervesHub server, the configuration\nkeys for specifying the device endpoint for the server have changed. Look for\n`:device_api_host` and `:device_api_port` in the documentation and example for\nsetting these.\n\n* Enhancements\n  * All firmware metadata is now passed up to the NervesHub. This will make it\n    possible for the server to make decisions on firmware that has been loaded\n    outside of NervesHub or old firmware that has been unloaded from NervesHub.\n  * Code cleanup and refactoring throughout. More passes are planned.","ref":"changelog.html#v0-4-0","title":"v0.4.0 - Changelog","type":"extras"},{"doc":"* Enhancements\n  * Add uuid and dn to http headers for polling requests\n\n* Bug fixes\n  * Fix crash when no updates were available","ref":"changelog.html#v0-3-0","title":"v0.3.0 - Changelog","type":"extras"},{"doc":"* Bug fixes\n  * Use CA certificates from `:nerves_hub` instead of `:nerves_hub_core`.","ref":"changelog.html#v0-2-1","title":"v0.2.1 - Changelog","type":"extras"},{"doc":"* Enhancements\n  * Updated docs.\n  * Added support for [NervesKey](https://github.com/nerves-hub/nerves_key).\n  * Added support for performing conditional updates.\n  * Include `fwup` elixir dependency for interfacing with `fwup`.\n  * Update deps and code to make it possible to run on host for testing.\n  * Automatically call `NervesHub.connect()` instead of requiring it to be specified.\n  * Improved error handling and reporting.","ref":"changelog.html#v0-2-0","title":"v0.2.0 - Changelog","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0","title":"v0.1.0 - Changelog","type":"extras"}],"producer":{"name":"ex_doc","version":"0.35.1"},"proglang":"elixir"}